// tclSynthesize application
//		-inspired by tclEDA + needs tclEDA tclsupport, tclimport and tclexport - ensure their avalability directly or as static .lib
//	tclSynthesize tclscriptfile - runs the tclscriptfile in console
//	or anything else runs GUI
///////////////////////////////////////////////////////////////////
#include <tcl.h>
#include <tk.h>

//#include<unistd.h>
#include <iostream>

#pragma warning( push )
#pragma warning( disable: 4996 4100 4512 )	//usage of old stricmp and unreferenced parameter e and operator= in hub.h
#include "util/srvstreams.h"
#include "modules/import/import.h"
#include "modules/export/export.h"
#include "apps/tcleda/tclsupport.h"
#include "apps/tcleda/tclimport.h"
#include "apps/tcleda/tclexport.h"

#include "hub/hub.h"
#include "hub/location.h"
#include "hub/err.h"
#pragma warning( pop )

#include "tclSynthesizer.h"

hub::Hub theHub;

bool guiOn;
static TclCommandMap edaMap;
static char* scriptFile;

int Tcl_AppInit( Tcl_Interp* interp ){
	using namespace std;

	if( Tcl_Init(interp) == TCL_ERROR ) return TCL_ERROR;
	if( guiOn ) if( Tk_Init(interp) == TCL_ERROR ) return TCL_ERROR;

	try {
		// -------- configuration: compound modules -----------------------------
		TclImportConfigure();
		TclExportConfigure();

		// -------- configuration:  compound commands ---------------------------
		TclCompoundRegister (interp, "eda", edaMap);
		edaMap.Register ("import", &TclImport);
		edaMap.Register ("export", &TclExport);
		edaMap.Register ("synthesize", &tclSynthesizer);

		if(guiOn){
			if( Tcl_EvalFile( interp, scriptFile ) != TCL_OK ) throw "script error";
		}
		else{
			if( Tcl_EvalFile( interp, scriptFile ) != TCL_OK ) throw "script error";
		}

	} catch( std::runtime_error& e ) {
		errStream << "runtime exception: " << e.what() << endl;
		return TCL_ERROR;
	} catch( std::logic_error& e ) {
		errStream << "logic exception: " << e.what() << endl;
		return TCL_ERROR;
	} catch (...) {
		const char* reslt = Tcl_GetStringResult( interp );
		errStream <<  "unknown exception" << reslt <<endl;
		return TCL_ERROR;
	}
	return TCL_OK;
}

int main( int argc, char* argv[] ){
		if( argc == 2 ){
				guiOn = false;
				scriptFile = argv[1];
				Tcl_Main( 1, &scriptFile, Tcl_AppInit );
		}
		else{
			guiOn = true;
			scriptFile = "GUI.tcl";
			Tk_Main( 1, &scriptFile, Tcl_AppInit );
		}
	return 0;
}
