//class implementing SYNTHESIS module
//	-module translating from FSM into structured gate level description(as far as HUB structures allows)
//	-include this header from external projects
//author: Petr Kraus
//////////////////////////////////////////////////////////////////////////

#ifndef SYNTHESIZER_H
#define SYNTHESIZER_H

#pragma warning( push )
#pragma warning( disable : 4996 4100 )	//usage of old stricmp and unreferenced parameter e in hub
#include "hub/hub.h"
#include "hub/location.h"
#include "hub/err.h"
#pragma warning( pop )

#include "util/srvstreams.h"

#include "modules/StateMinimizer/StateMinimizer.h"
#include "modules/fsmcode/fsmcode.h"
#include "modules/Realizer/Realizer.h"

#include "AlgorithmIdentificator.h"
#include "Algorithms.h"

class Synthesizer
{
	hub::Hub* theHub;

public:

	Synthesizer( hub::Hub* theHub );
	~Synthesizer();

	//does everything necessery for synthesis.
	//src should be Behavioral FSM, dest just empty adress, src and dest architecture must be different, choose each algorithm from algorithms array
	void operator()( hub::SrcLocation& src, hub::DestLocation& dest, StateMinimizationAlgorithmIdentificator stateMinimizationAlgorithm, EncodingAlgorithmIdentificator encodingAlgorithm, RealizationAlgorithmIdentificator realizationAlgorithm  ); //functor - choose algorithms from static arrays
};

#endif
