library IEEE;
use ieee.Std_Logic_1164.all;
use ieee.numeric_std.all;

entity circuit is
  port (
    CLK : in std_logic;
    i1 : in std_logic;
    o1 : out std_logic;
    RST : in std_logic
  );
  architecture seq of circuit is
    signal GND : std_logic;
    signal IN0 : std_logic;
    signal input0 : std_logic;
    signal input1 : std_logic;
    signal OUT0 : std_logic;
    signal output0 : std_logic;
    signal output1 : std_logic;
    
    component decoder3to3
      port (
	IN[0] : in std_logic;
	INSTATE[0] : in std_logic;
	INSTATE[1] : in std_logic;
	OUT[0] : out std_logic;
	OUTSTATE[0] : out std_logic;
	OUTSTATE[1] : out std_logic
      );
    end component;
    
    component DFF2
      port (
	CLK : in std_logic;
	D[0] : in std_logic;
	D[1] : in std_logic;
	Q[0] : out std_logic;
	Q[1] : out std_logic;
	RST[0] : in std_logic;
	RST[1] : in std_logic;
	SET[0] : in std_logic;
	SET[1] : in std_logic
      );
    end component;
    
  begin
  
    decodertransitionsDecoder: decoder3to3
     port map(
       IN[0] => IN0,
       OUT[0] => OUT0,
       INSTATE[0] => output0,
       INSTATE[1] => output1,
       OUTSTATE[0] => input0,
       OUTSTATE[1] => input1
     );
    DFFstateMemory: DFF2
     port map(
       CLK => CLK,
       D[0] => input0,
       Q[0] => output0,
       SET[0] => GND,
       RST[0] => RST,
       D[1] => input1,
       Q[1] => output1,
       SET[1] => RST,
       RST[1] => GND
     );
    GND <= '0';
    IN0 <= i1;
    o1 <= OUT0;
  end architecture seq;
  
end entity circuit;
